<?php
// $Id: simple_contest.admin.inc,v 1.1.2.1 2010/07/09 04:36:13 vinoth.3v Exp $

/**
 * @file
 * simple_contest settings form.
 */

/**
 * simple_contest settings form.
 */
function simple_contest_admin_settings(){
  //TODO: any global settings we have?
  $form = array();
  return $form;
}

function simple_contest_admin_settings_submit($form, &$form_state) {

  //$values = $form_state['values'];

  drupal_set_message(t('Your changes have been saved.'));

}

/**
 * simple_contest settings form.
 */
function simple_contest_content_type_settings_form(&$form_state, $type) {
  
  $form['type'] = array(
    '#type' => 'value',
    '#value' => $type,
  );

  $form['#action'] = url('admin/content/node-type/'. str_replace('_', '-', $type) .'/simple_contest');
  
  $settings = simple_contest_get_settings($type, TRUE);

  $form['simple_contest'] = array(
    '#type' => 'fieldset',
    '#title' => t('Simple contest'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
    '#weight' => 0,
  );

  $options = array('user' => 'User', 'node' => 'Node');

  $winner_type = isset($form_state['values']['winner_type']) 
    ?  $form_state['values']['winner_type'] 
    :  $settings['winner_type'];
  
  $form['simple_contest']['winner_type'] = array(
    '#type' => 'select',
    '#title' => t('Winner type'),
    '#default_value' => $winner_type,
    '#options' => $options,
    '#required' => TRUE,
    '#description' => t('Specify the winner type for this contest.
    	If node is selected, the winner selction view specified below must have the nid field in result. Otherwise it needs uid field.
    '),  
  );

  $form['simple_contest']['winner_selection_type'] = array(
    '#type' => 'select',
    '#title' => t('Winner selection type'),
    '#default_value' => $settings['winner_selection_type'],
    '#options' => array('auto' => t('Auto'), 'manual' => t('Manual'),),
    '#required' => TRUE,
    '#description' => t('Winners selection type. Auto: specified view will be used to select the winner(s) automatically. It needs CRON. Manual: Admin can select the winner(s).'),
  );

  $options_views = array('' => t('Select a View'));

  $views = views_get_all_views();

  foreach ($views as $name => $view) {
    if ($view->disabled == 0) {
      $options_views[$name] = $name;
    }
  }

  $view = isset($form_state['values']['view'])?$form_state['values']['view']:$settings['view'];

  $form['simple_contest']['view'] = array(
    '#type' => 'select',
    '#title' => t('Select view for winner selection'),
    '#default_value' => $view,
    '#options' => $options_views,
    '#required' => TRUE,
	'#description' => t('This view will be used to finalize the winners.'),  
	'#ahah' => array(
      'path' => 'simple_contest/ahah/view/fields',
      'wrapper' => 'simple_contest_view_field_wrapper',
      'effect' => 'fade',
      'method' => 'replace',
  ),
  );

  $fields = array();
  if($settings['view']){
    $fields = _simple_contest_get_view_fields($view);
  }else{
    $fields = array('nid' => t('Node ID'));
  }
  $form['simple_contest']['view_field'] = array(
    '#type' => 'select',
    '#title' => t('View field that has Node ID or User ID value'),
    '#default_value' => $settings['view_field'],
    '#options' => $fields,
    '#required' => TRUE,
    '#description' => t('Select this depends on the Contest type. If it is a node contest select Node ID field, User id field otherwise.'),
 	'#prefix' => '<div id="simple_contest_view_field_wrapper">',
  	'#suffix' => '</div>',
  );

  $form['simple_contest']['results_display'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display a result view in contest node page?'),
    '#options' => array(0 => 0, 1 => 1),
    '#default_value' => $settings['results_display'],
    '#required' => FALSE,
  );
  $form['simple_contest']['results_display_view'] = array(
    '#type' => 'select',
    '#title' => t('Results display view'),
    '#default_value' => $settings['results_display_view'],
    '#options' => $options_views,
    '#required' => FALSE,
    '#description' => t('This view will be used to display the winners.'),
  );

  $form['simple_contest']['max_winners'] = array(
      '#type' => 'select',
      '#title' => t('Maximum winners'),
      '#default_value' => $settings['max_winners'],
      '#options' => array(1=>1, 2=>2, 3=>3, 4=>4, 5 => 5, 10 =>10, 15=>15, 20=>20, 25=>25, 50=>50),
  );

  $form['simple_contest']['date_field'] = array(
    '#type' => 'select',
    '#title' => t('Date field to be used for contest'),
    '#options' => _simple_contest_date_fields($type),
    '#default_value' => $settings['date_field'],
    '#description' => t('Select a date field of this content type to use for contest Start and End dates. '),
    '#required' => TRUE,
  );

  $form['email'] = array(
    '#type' => 'fieldset',
    '#title' => t('E-mail Settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#weight' => 1,
  );
  $form['email']['email_to_winner'] = array(
  	'#type' => 'checkbox',
  	'#title' => t('E-mail to winner'),
  	'#default_value' => $settings['email_to_winner'],
  	'#options' => array(0 => 0, 1 => 1),
  	'#required' => FALSE,
  );
  $form['email']['email_to_winner_subject'] = array(
  	'#type' => 'textfield',
  	'#title' => t('Winner e-mail subject'),
  	'#default_value' => $settings['email_to_winner_subject'],
  );
  $form['email']['email_to_winner_body'] = array(
  	'#type' => 'textarea',
  	'#title' => t('Winner e-mail body'),
  	'#default_value' => $settings['email_to_winner_body'],
  	'#rows' => 10,
  );

  $form['email']['email_to_participants'] = array(
    '#type' => 'checkbox',
    '#title' => t('E-mail to participants'),
    '#default_value' => $settings['email_to_participants'],
    '#options' => array(0 => 0, 1 => 1),
    '#required' => FALSE,
  );
  $form['email']['email_to_participants_subject'] = array(
    '#type' => 'textfield',
    '#title' => t('Participants e-mail subject'),
    '#default_value' => $settings['email_to_participants_subject'],
  );

  $form['email']['email_to_participants_body'] = array(
    '#type' => 'textarea',
    '#title' => t('Participants e-mail body'),
    '#default_value' => $settings['email_to_participants_body'],
    '#rows' => 10,
  );

  $view = isset($form_state['values']['email_to_participants_view'])
  ?  $form_state['values']['email_to_participants_view']
  :  $settings['email_to_participants_view'];

  $form['email']['email_to_participants_view'] = array(
    '#type' => 'select',
    '#title' => t('Select a view that returns all participants details'),
    '#default_value' => $view,
    '#options' => $options_views,
    '#required' => FALSE,
	'#description' => t('This view will be used to get all participants details. This view must has nid (if node contest), Uid, User name, User E-mail.'),
  	'#ahah' => array(
      'path' => 'simple_contest/ahah/email/view/fields',
      'wrapper' => 'simple_contest_email_view_field_wrapper',
      'effect' => 'fade',
      'method' => 'replace',
    ),
  );

  $fields = array();

  if($view){
    $fields = _simple_contest_get_view_fields($view);
  }else{
    $fields = array('uid' => t('User ID'), 'nid' => t('Node ID'));
  }

  $form['email']['email_to_participants_view_field_uid'] = array(
		'#type' => 'select',
		'#title' => t('View field that has User ID value'),
		'#default_value' => $settings['email_to_participants_view_field_uid'],
		'#options' => $fields,
		'#required' => FALSE,
		'#description' => t('Select the User ID field from the view selected above.'),
        '#prefix' => '<div id="simple_contest_email_view_field_wrapper">',
  );
  //if ($winner_type == 'node'){
    $form['email']['email_to_participants_view_field_nid'] = array(
  		'#type' => 'select',
  		'#title' => t('View field that has Node ID value'),
  		'#default_value' => $settings['email_to_participants_view_field_nid'],
  		'#options' => $fields,
  		'#required' => FALSE,
  		'#description' => t('Select the Node ID field from the view selected above. optional if contest type is User.'),
    	'#suffix' => '</div>'
    );
 /* } else {
    $form['email']['email_to_participants_view_field_nid'] = array(
      '#type' => 'value',
      '#value' => $settings['email_to_participants_view_field_nid'],
    );
    $form['email']['email_to_participants_view_field_uid']['#suffix'] = '</div>';
  }*/

  $form['email']['email_to_admin'] = array(
		'#type' => 'checkbox',
		'#title' => t('E-mail to admin'),
		'#default_value' => $settings['email_to_admin'],
		'#options' => array(0 => 0, 1 => 1),
		'#required' => FALSE,
  );
  $form['email']['email_to_admin_subject'] = array(
		'#type' => 'textfield',
		'#title' => t('admin e-mail subject'),
		'#default_value' => $settings['email_to_admin_subject'],
  );

  $form['email']['email_to_admin_body'] = array(
		'#type' => 'textarea',
		'#title' => t('Admin e-mail body'),
		'#default_value' => $settings['email_to_admin_body'],
		'#rows' => 10,
  );

  $form['email']['token_help'] = array(
    '#title' => t('Replacement patterns'),
    '#type' => 'fieldset',
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['email']['token_help']['help'] = array(
  	'#value' => theme('token_help', 'simple_contest'),
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#weight' => 10,
  );

  return $form;
}

function simple_contest_content_type_settings_form_validate($form, &$form_state) {
  //
  $values = $form_state['values'];
  if( $values['email_to_participants'] && empty($values['email_to_participants_view'])) {
    form_set_error('email_to_participants_view', t('The view should be specified if E-mail to participants is enabled!'));
  }
  if( $values['results_display'] && empty($values['results_display_view'])) {
    form_set_error('results_display_view', t('The results display view should be specified if display a result view in contest node page is checked!'));
  }

}

function simple_contest_content_type_settings_form_submit($form, &$form_state) {

  $type = $form_state['values']['type'];
  
  $values = $form_state['values'];
  $settings = simple_contest_get_settings($type, TRUE);
  
  $settings['type'] = $type;

  foreach ($settings as $setting => $default) {
    $settings[$setting] = $values[$setting];
  }

  variable_set('simple_contest_' . $type, $settings);

  drupal_set_message('Your changes have been saved.');

}

/**
 * AHAH menu handler
 */
function simple_contest_content_type_settings_view_fields() {

  $form_state = array('storage' => NULL, 'submitted' => FALSE);
  $form_build_id = $_POST['form_build_id'];
  $form = form_get_cache($form_build_id, $form_state);
  $form_state['post'] = $form['#post'] = $_POST;
  $form['#programmed'] = $form['#redirect'] = FALSE;
  $args = $form['#parameters'];

  $form['#cache'] = TRUE;
  $form_id = array_shift($args);

  $form_state['values']['view'] = $form_state['post']['view'];
  $form_state['values']['winner_type'] = $form_state['post']['winner_type'];

  $form = drupal_rebuild_form($form_id, $form_state, $args, $form_build_id);

  $javascript = drupal_add_js(NULL, NULL, 'header');
  echo drupal_to_js(array(
    'status' => TRUE,
    'data' => drupal_render($form['simple_contest']['view_field']) ,
    'settings' => call_user_func_array('array_merge_recursive', $javascript['setting']),
  ));
  exit;
}

/**
 * AHAH menu handler
 */
function simple_contest_content_type_settings_email_view_fields() {

  $form_state = array('storage' => NULL, 'submitted' => FALSE);
  $form_build_id = $_POST['form_build_id'];
  $form = form_get_cache($form_build_id, $form_state);
  $form_state['post'] = $form['#post'] = $_POST;
  $form['#programmed'] = $form['#redirect'] = FALSE;
  $args = $form['#parameters'];

  $form['#cache'] = TRUE;
  $form_id = array_shift($args);

  $form_state['values']['email_to_participants_view'] = $form_state['post']['email_to_participants_view'];
  $form_state['values']['winner_type'] = $form_state['post']['winner_type'];

  $form = drupal_rebuild_form($form_id, $form_state, $args, $form_build_id);

  $javascript = drupal_add_js(NULL, NULL, 'header');

  $output = drupal_render($form['email']['email_to_participants_view_field_uid']);
  if ($form_state['post']['winner_type'] == 'node') {
    $output .= drupal_render($form['email']['email_to_participants_view_field_nid']);
  }
  echo drupal_to_js(array(
    'status' => TRUE,
    'data' => $output,
    'settings' => call_user_func_array('array_merge_recursive', $javascript['setting']),
  ));
  exit;
}

/**
 * Helper function _simple_contest_date_fields
 *
 * @param $content_type
 * @return
 */
function _simple_contest_date_fields($content_type = NULL) {
  $fields = array();
  $content_type_info = _content_type_info();
  if ($content_type_info['content types'][$content_type]) {
    foreach ($content_type_info['content types'][$content_type]['fields'] as $field) {
      if (in_array($field['type'], array('date', 'datestamp', 'datetime'))) {
        $fields[$field['field_name']] = $field['widget']['label'];
      }
    }
  }
  return $fields;
}
